# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %without mead
%bcond_without repolib
%else
%bcond_with repolib
%endif

%define reltag .redhat_4
%define namedreltag -redhat-4
%global namedversion %{version}%{?namedreltag}

%define maven_version 1.3.2-redhat-4

Name:           xmltooling
Version:        1.3.2
Release:        10%{?reltag}%{?dist}
Epoch:          0
Summary:        XMLTooling-J
License:        ASL 2.0
Group:          Development/Java

%if %with mead
Source100: org.opensaml-xmltooling-1.3.2-redhat-4-sources.zip
Source101: org.opensaml-xmltooling-1.3.2-redhat-4-patches.zip
Source102: xmltooling-1.3.2-redhat-4-bin.zip
Source103: xmltooling-1.3.2-redhat-4-javadoc.jar
Source104: xmltooling-1.3.2-redhat-4.jar
Source105: xmltooling-1.3.2-redhat-4-bin.tar.gz
Source106: xmltooling-1.3.2-redhat-4-src.zip
Source107: xmltooling-1.3.2-redhat-4.pom
Source108: xmltooling-1.3.2-redhat-4-src.tar.gz
Source109: xmltooling-1.3.2-redhat-4-sources.jar
%endif

URL:            http://www.opensaml.org/
%if 0
rm -rf xmltooling-1.3.2.tar.bz2 xmltooling-1.3.2/ .gitignore
svn -q export -r 741 https://svn.shibboleth.net/java-xmltooling/tags/1.3.2/ xmltooling-1.3.2/
tar cjf xmltooling-1.3.2.tar.bz2 xmltooling-1.3.2/
rhpkg new-sources xmltooling-1.3.2.tar.bz2
rhpkg prep
%endif
%if %without mead
Source0:        xmltooling-1.3.2.tar.bz2
Patch0:         000-xmltooling-pom.patch
Patch1:         001-xmltooling-vman.patch
Patch2:         002-xmltooling-assembly-src.patch
Patch3:         003-xmltooling-no-commons-ssl.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       jcip-annotations
Requires:       joda-time
Requires:       slf4j
Requires:       xml-security
%if %without mead
BuildRequires:  slf4j-api
BuildRequires:  jcl-over-slf4j
BuildRequires:  log4j-over-slf4j
BuildRequires:  jul-to-slf4j
BuildRequires:  joda-time >= 0:1.6.2
BuildRequires:  bcprov >= 0:1.45
# XXX: xmlsec
BuildRequires:  xml-security >= 0:1.4.4
BuildRequires:  not-yet-commons-ssl >= 0:0.3.9
BuildRequires:  jcip-annotations >= 0:1.0
#BuildRequires:  xml-apis
# XXX: xercesImpl
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-resolver >= 0:1.2
# XXX: xalan
BuildRequires:  xalan-j2 >= 0:2.7.1
BuildRequires:  junit >= 0:3.8.1
BuildRequires:  xmlunit >= 0:1.0
BuildRequires:  logback-classic >= 0:0.9.24
BuildRequires:  maven-compiler-plugin >= 0:2.3.2
BuildRequires:  maven-assembly-plugin >= 0:2.2.1
BuildRequires:  maven-surefire-plugin >= 0:2.8
BuildRequires:  maven-jar-plugin >= 0:2.3.1
BuildRequires:  maven-source-plugin >= 0:2.1.2
BuildRequires:  maven-javadoc-plugin >= 0:2.7
BuildRequires:  maven-javadoc-plugin >= 0:2.7
BuildRequires:  maven-jxr-plugin >= 0:2.2
BuildRequires:  maven-surefire-report-plugin >= 0:2.8
#
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-default-skin
BuildRequires:  maven-jxr-plugin
BuildRequires:  maven-source-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  surefire-junit4
%else
BuildRequires:  unzip
%endif
BuildRoot:      %{_tmppath}/xmltooling-%{namedversion}-%{release}-root
BuildArch:      noarch

%description
XMLTooling-J is a low-level library that may be used to construct
libraries that allow developers to work with XML in a Java beans manner.

%package javadoc
Summary:        Javadoc for xmltooling
Group:          Development/Documentation

Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3
%else
%setup -q -n java-xmltooling -T -b 100
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://`pwd`/maven2-brew
export MAVEN_OPTS=
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip -Dmaven.test.failure.ignore deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/xmltooling-%{namedversion}.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}.jar
%{__cp} -p target/xmltooling-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}-javadoc.jar
%{__cp} -p target/xmltooling-%{namedversion}-sources.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}-sources.jar
%{__cp} -p target/xmltooling-%{namedversion}-bin.tar.gz %{buildroot}%{_javadir}/xmltooling-%{namedversion}-bin.tar.gz
%{__cp} -p target/xmltooling-%{namedversion}-src.tar.gz %{buildroot}%{_javadir}/xmltooling-%{namedversion}-src.tar.gz
%{__cp} -p target/xmltooling-%{namedversion}-bin.zip %{buildroot}%{_javadir}/xmltooling-%{namedversion}-bin.zip
%{__cp} -p target/xmltooling-%{namedversion}-src.zip %{buildroot}%{_javadir}/xmltooling-%{namedversion}-src.zip
%else
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}-javadoc.jar
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-sources.jar %{buildroot}%{_javadir}/xmltooling-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-bin.tar.gz %{buildroot}%{_javadir}/xmltooling-%{namedversion}-bin.tar.gz
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-src.tar.gz %{buildroot}%{_javadir}/xmltooling-%{namedversion}-src.tar.gz
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-bin.zip %{buildroot}%{_javadir}/xmltooling-%{namedversion}-bin.zip
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}-src.zip %{buildroot}%{_javadir}/xmltooling-%{namedversion}-src.zip
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-xmltooling.pom
%else
%{__cp} -p %{_sourcedir}/xmltooling-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-xmltooling.pom
%endif

# depmap
%add_to_maven_depmap org.opensaml xmltooling %{namedversion} JPP xmltooling

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/xmltooling-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/xmltooling-%{namedversion}
%else
%{_bindir}/unzip -qq %{_sourcedir}/xmltooling-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/xmltooling-%{namedversion} -x META-INF/\*
%endif
%{__ln_s} xmltooling-%{namedversion} %{buildroot}%{_javadocdir}/xmltooling

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/xmltooling-%{namedversion}.jar
%{_javadir}/xmltooling.jar
%{_javadir}/xmltooling-%{namedversion}-sources.jar
%{_javadir}/xmltooling-sources.jar
%{_javadir}/xmltooling-%{namedversion}-bin.tar.gz
%{_javadir}/xmltooling-bin.tar.gz
%{_javadir}/xmltooling-%{namedversion}-src.tar.gz
%{_javadir}/xmltooling-src.tar.gz
%{_javadir}/xmltooling-%{namedversion}-bin.zip
%{_javadir}/xmltooling-bin.zip
%{_javadir}/xmltooling-%{namedversion}-src.zip
%{_javadir}/xmltooling-src.zip
%{_mavenpomdir}/JPP-xmltooling.pom
%{_mavendepmapfragdir}/xmltooling

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/xmltooling-%{namedversion}
%{_javadocdir}/xmltooling
%{_javadir}/xmltooling-%{namedversion}-javadoc.jar
%{_javadir}/xmltooling-javadoc.jar

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Apr 24 2013 David Walluck <dwalluck@redhat.com> 0:1.3.2-10
- convert to MEAD
- add javadoc jar to javadoc subpackage
- fix file list
- add tars and zips to RPM

* Fri Mar 08 2013 Fernando Nasser <fnasser@redhat.com> 0:1.3.2-9
- Do not require not-yet-commons-ssl, not used by the AS7

* Tue Sep 04 2012 Paul Gier <pgier@redhat.com> 0:1.3.2-8
- Update pom patch for unsigned rebuild

* Mon May 22 2012 Yong Yang <yyang@redhat.com> 0:1.3.2-7
- Update pom patch

* Mon May 14 2012 David Walluck <dwalluck@redhat.com> 0:1.3.2-6
- remove xml runtime deps from Requires and pom.xml

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:1.3.2-5
- need to set the local repo

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:1.3.2-4
- bcprov should be marked optional

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:1.3.2-3
- rediff vman patch
- bcprov is jdk16, not jdk15
- fix some groupIds
- requires xalan, xerces, xml-resolver
- xmlunit is not a Requires
- fix repolib file ownership
- fix maven call
- fix javadoc pkg

* Mon Nov 21 2011 Yong Yang <yyang@redhat.com> 1.3.2-2_redhat_1
- Build for Werewolf

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.3.2-1
- Upgrade to 1.3.2

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.3.1-5
- Do not create backup file because the file will be packed into src zip

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.3.1-4
- Comment dependencySets in assembly src.xml, tar.gz only

* Fri Sep 30 2011 Yong Yang <yyang@redhat.com> 1.3.1-3
- Remove R: logback

* Fri Sep 30 2011 Yong Yang <yyang@redhat.com> 1.3.1-2
- Fix file list

* Fri Sep 30 2011 Yong Yang <yyang@redhat.com> 1.3.1-2
- Remove binary repo, BR not-yet-commons-ssl

* Thu Sep 29 2011 Yong Yang <yyang@redhat.com> 1.3.1-1
- Upgrade to 1.3.1
- Add repolib

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 1.2.0-2
- Auto rebuild for JPackage 6 in centos5 mock

* Fri Jun 12 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.2.0-1.jpp5
- 1.2.0

* Thu Jun 04 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.1-1.jpp5
- first release
